<?php
/**
 * @package FlattRSS
 * @author Michael Henke
 * @version 1.1.4
 */
/*
Plugin Name: FlattRSS
Plugin URI: http://wordpress.org/extend/plugins/flattrss/
Description: This plugin is including the Flattr button in your RSS/Atom feed. There are some options to extend Flattr functionality like optional autosubmit on new post publish. <a href="https://flattr.com/thing/242/Wordpress-Flattr-RSS-plugin" target="_blank">Flattr this!</a>
 * Version: 1.1.4
Author: Michael Henke
Author URI: http://allesblog.de
*/
if (session_id() == '') { session_start(); }

add_action('admin_menu', 'flattrss_config_page');
add_action('init', 'flattrss_redirect');
add_action('admin_init', 'flattrss_callback');

define(FLATTRSS_WP_VERSION, '1.1.4');
define(FLATTRSS_PLUGIN_PATH, get_bloginfo('wpurl') . '/wp-content/plugins/flattrss');

include_once 'oAuth/flattr_rest.php';
include_once 'oAuth/oauth.php';

function flattrss_config_page() {

    if ( class_exists('Flattr')) {
        add_submenu_page( 'flattr/settings.php', __('Flattr for RSS/Atom'), __('Flattr for RSS/Atom'), 8, 'flattrss/flattrss.php', 'flattrss_options');
    }else{
        add_options_page('Flattr RSS', 'Flattr RSS', 8, basename(__FILE__), 'flattrss_options');
    }
}

function flattrss_options() {

    $server = $_SERVER["SERVER_NAME"];
    $server = preg_split("/:/", $server);
    $server = $server[0];


?>
      <div class="wrap flattrss-wrap">
      <div>
      <div style="<?php echo get_option('flattrss_autodonate')? "": "width:65%; " ?>float:left;">
      <h2><img src="<?php echo FLATTRSS_PLUGIN_PATH .'/img/flattr_button.png' ?>" alt="flattr"/>&nbsp;Flattr RSS Options</h2>
      <p>This plugin will create a Flattr button in your RSS/Atom feed items, so that readers can Flattr directly from their reader application.</p>
<?php
    $oauth_token = get_option('flattrss_api_oauth_token');
    $oauth_token_secret = get_option('flattrss_api_oauth_token_secret');

    if ($oauth_token == $oauth_token_secret) {
       
    if ( class_exists('Flattr')) {
?>
      <p>Despite <em>maybe</em> beeing authorized already to the original Flattr plugin it is still necessary to authorize your Flattr Feed feature against your own flattr blog app. This is by design.</p>
<?php
    }
?>
      <ol>
          <li>Login to your Flattr Account at <a href="https://flattr.com/" target="_blank">flattr.com</a></li>
          <li>To get your personal Flattr APP Key and APP Secret you need to <a href="https://flattr.com/apps/new" target="_blank">register your blog</a> as Flattr app. <small><a href="http://developers.flattr.net/doku.php/register_your_application" target="_blank">(More Info)</a></small></li>
          <li>Choose reasonable values for <em>Application name</em>, <em>Application website</em> and <em>Application description</em></li>
          <li>It is mandatory to <strong>select BROWSER application type!</strong> This plugin will currently <strong>not work if CLIENT is selected</strong>.</li>
          <li>You must use <code><?php echo $server; ?></code> as callback domain.</li>
          <li>Copy 'n Paste your APP Key and APP Secret in the corresponding fields below. Save Changes.</li>
          <li>As soon as you saved your APP information <a href="#Authorize">authorize</a> your Flattr account with your own application.</li>
          <li>If everything is done correctly you'll see your <a href="#UserInfo">Flattr username and info</a> on this site.</li>
      </ol>
<?php
      }
?>
      <form method="post" action="options.php">
        <?php wp_nonce_field('update-options'); ?>
        <table class="form-table">
            <tr valign="top">
                <th scope="row">Callback Domain</th>
                <td><input size="30" value="<?php echo $server; ?>" readonly/></td>
            </tr>
            <tr valign="top">
                <th scope="row">APP_KEY</th>
                <td><input size="70" name="flattrss_api_key" value="<?php echo get_option('flattrss_api_key') ?>"/></td>
            </tr>
            <tr valign="top">
                <th scope="row">APP_SECRET</th>
                <td><input size="70" name="flattrss_api_secret" value="<?php echo get_option('flattrss_api_secret') ?>"/></td>
            </tr>
            <tr valign="top">
                <th scope="row">Automatic Submission</th>
                <td><input name="flattrss_autosubmit" type="checkbox"<?php echo get_option('flattrss_autosubmit')? " checked": "" ?>/><br/>
                    <p>Check this box to automatically submit your blog post when you publish.</p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row">Automatic Donation</th>
                <td><input name="flattrss_autodonate" type="checkbox"<?php echo get_option('flattrss_autodonate')? " checked": "" ?>/><br/>
                    <p>Check this box to show your appreciation for FlattrRSS and automatically flattr FlatrRSS once a month. <small>(beta)</small></p>
                    <p>This option is never stealing away any of your clicks.</p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row">Track Clicks</th>
                <td><input name="flattrss_clicktrack_enabled" type="checkbox"<?php echo get_option('flattrss_clicktrack_enabled')? " checked": "" ?>/><br/>
                    <p>Track clicks through the RSS feed. <small>(Note: this equals not the actual number of recieved flattr clicks via FlattRSS)</small></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row">Custom Image URL</th>
                <td><input name="flattrss_custom_image_url" size="70" value="<?php echo get_option('flattrss_custom_image_url');?>"/><br/>
                    <?php if ( get_option('flattrss_custom_image_url') != FLATTRSS_PLUGIN_PATH .'/img/flattr-badge-large.png') { ?>
                    Default Value:<br>
                    <input size="70" value="<?php echo FLATTRSS_PLUGIN_PATH .'/img/flattr-badge-large.png';?>" readonly><br />
                    <?php } ?>
                    Preview:<br>
                    <img src="<?php echo get_option('flattrss_custom_image_url');?>">
                    <p></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row">Suppress Warnings</th>
                <td><input name="flattrss_error_reporting" type="checkbox"<?php echo get_option('flattrss_error_reporting')? " checked": "" ?>/><br/>
                    <p>This is an advanced option for supression of error messages upon redirect from feed to thing. Use with caution, as flattr things might be submitted incomplete. Incomplete things are subject to be hidden on the flattr homepage!<br>If in doubt, leave disabled.</p>
                </td>
            </tr>
        </table>

    <p class="submit">
    <input type="submit" class="button-primary" value="Save Changes" />
    <input type="reset" class="button" value="Reset" />
    </p>

    <input type="hidden" name="action" value="update" />
    <input type="hidden" name="page_options" value="flattrss_api_key,flattrss_api_secret,flattrss_autodonate,flattrss_clicktrack_enabled,flattrss_error_reporting,flattrss_custom_image_url,flattrss_autosubmit" />
    </form>
<?php
    
    $api_key = get_option('flattrss_api_key');
    $api_secret = get_option('flattrss_api_secret');

    if ($api_key != $api_secret) {

    $flattr = new Flattr_Rest($api_key, $api_secret);

    if (!isset($_SESSION['flattrss_current_token']) || empty ($_SESSION['flattrss_current_token'])) {

        $token = "";
        if ( class_exists('Flattr')) {
            $token = $flattr->getRequestToken(get_bloginfo('wpurl').'/wp-admin/admin.php?page=flattrss/flattrss.php');
        } else {
            $token = $flattr->getRequestToken(get_bloginfo('wpurl').'/wp-admin/options-general.php?page=flattrss.php');
        }

        $_SESSION['flattrss_current_token'] = $token;
    } else {
        $token = $_SESSION['flattrss_current_token'];
    }

    $url = $flattr->getAuthorizeUrl($token, 'read,readextended,click,publish');

        ?><a name="Authorize"><div id="icon-options-general" class="icon32"><br /></div><h2>Authorize App</h2></a>
        <p>In order to automatically generate the correct "<em>Things</em>" link for your blog post from the feed, you need to authorize you Flattr app with your Flattr account.</p>
          <p><a href="<?php echo $url;?>">(re-)Authorize with Flattr</a>.
<?php

    $oauth_token = get_option('flattrss_api_oauth_token');
    $oauth_token_secret = get_option('flattrss_api_oauth_token_secret');

    if ($oauth_token != $oauth_token_secret) {
        $flattr_user = new Flattr_Rest($api_key, $api_secret, $oauth_token, $oauth_token_secret);
        if ( $flattr_user->error() ) {
            echo( 'Error ' . $flattr_user->error() );
        }
        $user = $flattr_user->getUserInfo();
?>
    <div style="float:right"><img src="<?php echo $user['gravatar'];?>"></div><a name="UserInfo"><h2><img src="<?php echo FLATTRSS_PLUGIN_PATH .'/img/flattr_button.png' ?>" alt="flattr"/>&nbsp;Flattr User Info</h2></a>
    <p><?php echo $user['firstname'];?>&nbsp;<?php echo $user['lastname'];?><br/>
    <?php echo $user['username'];?>(<?php echo $user['id'];?>)</p>
    <p>Flattr: <a href="https://flattr.com/profile/<?php echo $user['username'];?>" target="_blank">Profile</a>, <a href="https://flattr.com/dashboard" target="_blank">Dashboard</a>, <a href="https://flattr.com/settings" target="_blank">Settings</a></p>
        <?php
        #print_r($user);
    }
  }
?>

      </div>
                <?php if (!get_option('flattrss_autodonate')) { include('donate.php'); } ?>
      </div>

</div><?php

}

$i = 0;

function post2rss($content) {
    global $post;

    $flattr = "";

    if (is_feed()) {
        $id = $post->ID;
        $md5 = md5($post->post_title);
        $permalink = urlencode(get_permalink( $id ));
        $posttags = get_the_tags();
        if ($posttags) {
            foreach($posttags as $tag) {
                $tags .= $tag->name . ',';
            }
            $tags = rtrim($tags,",");
        }
        $tags = urlencode($tags);

        $flattr.= ' <p><a href="'. get_bloginfo('wpurl') .'/?flattrss_redirect&amp;id='.$id.'&amp;md5='.$md5.'" title="Flattr" target="_blank"><img src="'. FLATTRSS_PLUGIN_PATH .'/img/flattr-badge-large.png" alt="flattr this!"/></a></p>';
    }

    return ($content.$flattr);
}

add_filter('the_content', 'post2rss');

//Default Options
add_option('flattrss_api_key', "");
add_option('flattrss_autodonate', false);
add_option('flattrss_api_secret', "");
add_option('flattrss_api_oauth_token',"");
add_option('flattrss_api_oauth_token_secret',"");
add_option('flattrss_custom_image_url', FLATTRSS_PLUGIN_PATH .'/img/flattr-badge-large.png');
add_option('flattrss_clicktrack_since_date', date("r"));
add_option('flattrss_clickthrough_n', 0);
add_option('flattrss_clicktrack_enabled', true);
add_option('flattrss_error_reporting', false);
add_option('flattrss_autosubmit', false);

function flattrss_redirect() {
    include_once 'redirect.php';
}

function flattrss_callback() {
    include_once 'callback.php';
}

if(is_admin()) {
    $admin_notice = "";
    if (!(function_exists("curl_init"))) {
        $admin_notice .= 'echo \'<div id="message" class="error"><p><strong>Error:</strong> Your PHP installation must support cURL for FlattRSS plugin to work!</p></div>\';';
    }

    $oauth_token = get_option('flattrss_api_oauth_token');
    $oauth_token_secret = get_option('flattrss_api_oauth_token_secret');

    if ($oauth_token == $oauth_token_secret) {
        $opt_url = get_bloginfo('wpurl') .'/wp-admin/options-general.php?page=flattrss.php';
        if ( class_exists('Flattr')) {
            $opt_url = get_bloginfo('wpurl') .'/wp-admin/admin.php?page=flattrss/flattrss.php';
        }

        $admin_notice .= 'echo \'<div id="message" class="updated"><p><strong>Warning:</strong> You need to <a href="'.$opt_url.'">configure FlattRSS plugin</a> before it works properly</p></div>\';';
    }

    if ($admin_notice != "") {
        add_action( 'admin_notices',
            create_function('', $admin_notice)
        );
    }
}

# Admin Dashboard Widget
// Create the function to output the contents of our Dashboard Widget

function flattrss_dashboard_widget() {
    // Display whatever it is you want to show
    $n = get_option('flattrss_clickthrough_n');
    if ($n == "") { $n = 0; }
    echo "<p class=\"sub\">Collected <strong>$n clicks via FlattRSS</strong> plugin. Counting since ". get_option('flattrss_clicktrack_since_date'). ". ";

    if (!get_option('flattrss_autodonate')) {
        echo "<a href=\"http://flattr.com/thing/242/Wordpress-Flattr-RSS-plugin\">Share some pie</a>.";
    }

    echo "</p>".
         "<p>Plugin Version: ".FLATTRSS_WP_VERSION."</p>";
}

// Create the function use in the action hook

function add_flattrss_dashboard_widget() {
	wp_add_dashboard_widget('flattrss_dashboard_widget', 'FlattRSS Dashboard', 'flattrss_dashboard_widget');
}

// Hook into the 'wp_dashboard_setup' action to register our other functions
if (get_option('flattrss_clicktrack_enabled')) {
    add_action('wp_dashboard_setup', 'add_flattrss_dashboard_widget' );
}

# Autosubmit Support

function flattrss_autosubmit_action () {

    global $call_n;
    
    $post = $_POST;

    if (($post['post_status'] == "publish") && ($post['original_post_status'] != "publish" && (strtotime($post['post_date_gmt']) - strtotime(gmdate("Y-m-d H:i:s")) <= 0)) && ($call_n == 1)) {
        
        $e = error_reporting();
        error_reporting(E_ERROR);

        $url = get_permalink($post['ID']);
        $tagsA = get_the_tags($post['ID']);
        $tags = "";

        if ($tagsA) {
            foreach ($tagsA as $tag) {
                if (strlen($tags)!=0){
                    $tags .=",";
                }
                $tags .= $tag->name;
            }
        }

        if (trim($tags) == "") {
            $tags .= "blog";
        }

        $category = "text";
        if (get_option('flattr_cat')!= "") {
            $category = get_option('flattr_cat');
        }

        $language = "en_EN";
        if (get_option('flattr_lng')!="") {
            $language = get_option('flattr_lng');
        }

        if (!function_exists('getExcerpt')) {
            function getExcerpt($post, $excerpt_max_length = 1024) {

                $excerpt = $post['post_excerpt'];
                if (trim($excerpt) == "") {
                        $excerpt = $post['post_content'];
                }

                $excerpt = strip_shortcodes($excerpt);
                $excerpt = strip_tags($excerpt);
                $excerpt = str_replace(']]>', ']]&gt;', $excerpt);

                // Hacks for various plugins
                $excerpt = preg_replace('/httpvh:\/\/[^ ]+/', '', $excerpt); // hack for smartyoutube plugin
                $excerpt = preg_replace('%httpv%', 'http', $excerpt); // hack for youtube lyte plugin

                // Try to shorten without breaking words
                if ( strlen($excerpt) > $excerpt_max_length ) {
                    $pos = strpos($excerpt, ' ', $excerpt_max_length);
                    if ($pos !== false) {
                            $excerpt = substr($excerpt, 0, $pos);
                    }
                }

                // If excerpt still too long
                if (strlen($excerpt) > $excerpt_max_length) {
                    $excerpt = substr($excerpt, 0, $excerpt_max_length);
                }

                return $excerpt;
            }
        }

        $content = preg_replace(array('/\<br\s*\/?\>/i',"/\n/","/\r/", "/ +/"), " ", getExcerpt($post));
        $content = strip_tags($content);

        if (strlen(trim($content)) == 0) {
            $content = "(no content provided...)";
        }

        $title = strip_tags($post['post_title']);
        $title = str_replace(array("\"","\'"), "", $title);

        $api_key = get_option('flattrss_api_key');
        $api_secret = get_option('flattrss_api_secret');
        $oauth_token = get_option('flattrss_api_oauth_token');
        $oauth_token_secret = get_option('flattrss_api_oauth_token_secret');

        $flattr_user = new Flattr_Rest($api_key, $api_secret, $oauth_token, $oauth_token_secret);

        if ($flattr_user->error()) {
            return;
        }

        if(!function_exists("encode")) {
            function encode($string) {
                if (function_exists("mb_detect_encoding")) {
                    $string = (mb_detect_encoding($string, "UTF-8") == "UTF-8" )? $string : utf8_encode($string);
                } else {
                    $string = utf8_encode($string);
                }
                return $string;
            }
        }

        #print_r(array($url, encode($title), $category, encode($content), $tags, $language));

        $flattr_user->submitThing($url, encode($title), $category, encode($content), $tags, $language);

        if (get_option('flattrss_autodonate') && !isset($_SESSION['flattrss_autodonate_click'])) {
            $flattr_user->clickThing("ead246fc95fc401ce69d15f3981da971");
            $_SESSION['flattrss_autodonate_click'] = true;
        }
        
        error_reporting($e);
    }
    $call_n = 1;
}

if (get_option('flattrss_autosubmit')) {
    add_action('save_post','flattrss_autosubmit_action',9999);
}

# Settings Button on Plugins Panel
function plugin_settings_link($links, $file) {

	static $this_plugin;
	if ( ! $this_plugin ) $this_plugin = plugin_basename(__FILE__);

	if ( $file == $this_plugin ){
		$settings_link = '<a href="options-general.php?page=flattrss.php">' . __('Settings', 'flatrss') . '</a>';
		array_unshift( $links, $settings_link );
	}

	return $links;

}

add_filter( 'plugin_action_links', 'plugin_settings_link', 10, 2 ); # Configure link on plugins.php